using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ID3TagEditLite {
    public partial class FormGenreDlg : Form {
        public int m_number;
        public Point m_localLocation;
        public Point m_parentDesktopLocation;

        public FormGenreDlg() {
            InitializeComponent();

            lstGenre.BeginUpdate();
            foreach (TGenreItem g in Program.theGenre.m_genres.Values) {
                lstGenre.Items.Add(g.GetNameForMenu());
            }
            lstGenre.EndUpdate();
        }

        public void Setup(int genreNumber) {
            m_number = genreNumber;
            int n = -1;
            TGenreItem g = Program.theGenre.GetGenreItemByGenreNumber(genreNumber);
            if (g != null) {
                n = Program.theGenre.m_genres.Values.IndexOf(g);
            }
            if (n >= 0 && n < lstGenre.Items.Count) {
                lstGenre.SelectedIndex = n;
            }
        }

        private void btnOK_Click(object sender, EventArgs e) {
            if (lstGenre.SelectedIndex >= 0) {
                TGenreItem g = Program.theGenre.m_genres.Values[lstGenre.SelectedIndex];
                m_number = g.m_number;
            }
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e) {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        public int GetGenre() {
            return m_number;
        }

        private void GenreDlg_Load(object sender, EventArgs e) {
            Point p = m_parentDesktopLocation;
            p.X += m_localLocation.X;
            p.Y += m_localLocation.Y;
            this.DesktopLocation = p;
        }

        private void GenreDlg_FormClosed(object sender, FormClosedEventArgs e) {
            m_localLocation.X = this.DesktopLocation.X - m_parentDesktopLocation.X;
            m_localLocation.Y = this.DesktopLocation.Y - m_parentDesktopLocation.Y;
        }
    }
}