using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace ID3TagEditLite {
    public partial class FormPreferencesDlg : Form {
        SortedList<int, string> m_cpList = new SortedList<int, string>();

        public FormPreferencesDlg() {
            InitializeComponent();
            CultureInfo[] cts = CultureInfo.GetCultures(CultureTypes.NeutralCultures);
            foreach (CultureInfo ct in cts) {
                int cp = ct.TextInfo.ANSICodePage;
                if (cp != 0 && m_cpList.ContainsKey(cp) == false) {
                    Encoding enc = Encoding.GetEncoding(cp);
                    string name = "CP" + cp.ToString() + " / " + enc.WebName.ToUpper() + " / " + enc.EncodingName;
                    m_cpList.Add(cp, name);
                }
            }
            foreach (string name in m_cpList.Values) {
                cbxCodePage.Items.Add(name);
            }
            if (m_cpList.ContainsKey(Program.thePref.ansiCodePage)) {
                cbxCodePage.SelectedIndex = m_cpList.Keys.IndexOf(Program.thePref.ansiCodePage);
            }
            chkNothingIsAll.Checked = Program.thePref.nothingIsAll;
        }

        private void btnOK_Click(object sender, EventArgs e) {
            Program.thePref.ansiCodePage = m_cpList.Keys[cbxCodePage.SelectedIndex];
            Program.thePref.nothingIsAll = chkNothingIsAll.Checked;
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e) {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
    }
}