using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
/*
struct ID3_V1 {
	char m_tag[3];
	char m_title[30];
	char m_artist[30];
	char m_album[30];
	char m_year[4];
	union {
		struct {
			char m_comment[30];
		}
		v10;
		struct {
			char m_comment[28];
			char m_null;
			char m_track;
		}
		v11;
	} u;
	char m_genre;
};
*/
namespace ID3TagEditLite {
    class TID3V1Tag {
        public const int TAG_SIZE = 128;

        public byte[] m_magic;
        public byte[] m_title;
        public byte[] m_artist;
        public byte[] m_album;
        public byte[] m_year;
        public byte[] m_comment;
        public byte m_null = 0x20;
        public byte m_track = 0;
        public byte m_genre = 0;
        
        public bool Read(BinaryReader br) {
            m_magic = br.ReadBytes(3);
            ASCIIEncoding ae = new ASCIIEncoding();
            if (ae.GetString(m_magic).Equals("TAG") == false)
                return false;
            m_title = br.ReadBytes(30);
            m_artist = br.ReadBytes(30);
            m_album = br.ReadBytes(30);
            m_year = br.ReadBytes(4);
            long pos = br.BaseStream.Position;
            m_comment = br.ReadBytes(28);
            m_null = br.ReadByte();
            if (m_null == 0) {
                // V11
                m_track = br.ReadByte();
            }
            else {
                // V10
                br.BaseStream.Seek(pos, SeekOrigin.Begin);
                m_comment = br.ReadBytes(30);
            }
            m_genre = br.ReadByte();
            return true;
        }
    }
}
