using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;

namespace ID3TagEditLite {
    /// <summary>
    /// ^OB
    /// </summary>
    public class TTagString {
        // BOM
        public const char CHAR_BOM_BIG_ENDIAN = (char)0xFFFE;
        public const char CHAR_BOM_LITTLE_ENDIAN = (char)0xFEFF;
        //
        public byte[] m_org = new byte[0];
        public TTagEncoding m_encoding = TTagEncoding.ANSI;
        public string m_str = "";

        public TTagString Clone() {
            TTagString s = new TTagString();
            if (m_org != null)
                s.m_org = (byte[])m_org.Clone();
            s.m_str = m_str;
            s.m_encoding = m_encoding;
            return s;
        }

        public void Set(byte[] data, int offset, int byteCount, TTagEncoding encoding) {
            if (byteCount > 0) {
                m_org = new byte[byteCount];
                Array.Copy(data, offset, m_org, 0, byteCount);
            }
            else {
                m_org = new byte[0];
            }
            m_encoding = encoding;
        }

        // m_org -> m_str
        public bool DecodeString(TTagEncoding code) {
            if (m_org.Length == 0) {
                m_str = "";
                m_encoding = TTagEncoding.ANSI;
                return false;
            }

            char[] trimChar = new char[] { '\0', ' ' };
            char[] uniTrimChar = new char[] { '\0', ' ', CHAR_BOM_BIG_ENDIAN, CHAR_BOM_LITTLE_ENDIAN };

            // iTunes̍^O͂̕ȂŌNULL܂ޒݒ肳ĂB
            // ĐƂĈɂ͂NULL폜KvB
            // dl͂NULLI[Kv͂ȂB
            if (m_encoding == TTagEncoding.UTF16 && m_org.Length >= 2) {
                UnicodeEncoding ue = new UnicodeEncoding();
                m_str = ue.GetString(m_org).Trim(uniTrimChar);
                if (m_str.Length == 1 && (m_str[0] == CHAR_BOM_BIG_ENDIAN || m_str[0] == CHAR_BOM_LITTLE_ENDIAN))
                    m_str = "";
            }
            else if (m_org.Length > 1) {
                Encoding enc = Encoding.GetEncoding(Program.thePref.ansiCodePage);
                m_str = enc.GetString(m_org).Trim(trimChar);
                m_encoding = TTagEncoding.ANSI;
            }
            else {
                m_str = "";
                m_encoding = TTagEncoding.ANSI;
            }
            return false;
        }

        // m_str -> m_org
        public void EncodeString(TTagEncoding code, int limit) {
            if (m_str.Length == 0) {
                if (m_org.Length > 0)
                    m_org = new byte[0];
                m_encoding = TTagEncoding.ANSI;
                return;
            }

            if (code == TTagEncoding.UTF16) {
                UnicodeEncoding ue = new UnicodeEncoding(false, true);
                m_org = TTools.UnionByteArray(ue.GetPreamble(), ue.GetBytes(m_str));
                m_encoding = TTagEncoding.UTF16;
            }
            else {
                Encoding enc = Encoding.GetEncoding(Program.thePref.ansiCodePage);
                m_org = enc.GetBytes(m_str);
                m_encoding = TTagEncoding.ANSI;
            }
            if (limit > 0 && m_org.Length > limit) {
                byte[] o = new byte[limit];
                Array.Copy(m_org, 0, o, 0, limit);
                m_org = o;
            }
        }

        public TTagEncoding CheckString() {
            TTagEncoding decodeAs = TTagEncoding.ANSI;
            if (m_org.Length == 0)
                return decodeAs;

            // Macintosh ł͂ɗLATIN1GR[h̔肪B
            // Windowsł͕svƎvB
            // ēʎ͂ȂB

            return decodeAs;
        }

    }

}
